# Rust编程指南

[为何创作本书](why-another.md)
[关于Rust语言](into-rust.md)

## Getting started

- [牛刀小试](first-try/intro.md)
    - [安装Rust环境](first-try/installation.md)
    - [墙推VSCode!](first-try/editor.md)
    - [认识Cargo](first-try/cargo.md)
    - [你好，世界!](first-try/hello-world.md)

## Rust学习三部曲

- [基本概念](basic/intro.md)
    - [变量绑定](basic/variable.md)
    - [基本类型](basic/type.md)
    - [复合类型](basic/compound-type.md)
    - [函数与方法](basic/function-method.md)
    - [格式化输出](basic/formatted-output.md)
    - [字符串、数组与切片](basic/string-array-slice.md)
    - [流程控制](basic/flow-control.md)
    - [返回、异常和错误](basic/exception-error.md)
    - [模式匹配](basic/match-pattern.md)
    - [文档注释](basic/comment.md)
    - [包和模块](basic/crate-module.md)
    - [语句与表达式](basic/statement-expression.md)

- [核心概念](core/intro.md)
    - [所有权](core/ownership.md)
    - [借用](core/borrowing.md)
    - [生命周期](core/lifetime.md)
    
- [进阶编程](advance/intro.md)
    - [泛型](advance/generitic.md)
    - [特征](advance/trait.md)
    - [迭代器](advance/interator.md)
    - [集合类型](advance/collection.md)
    - [函数式编程](advance/functional-programing.md)
    - [智能指针](advance/smart-pointer.md)
    - [多线程](advance/threads.md)
    - [测试](advance/tests.md)
    - [错误处理](advance/errors.md)
    - [宏](advance/macro.md)
    - [Bypass Borrow Checker](advance/bypass-borrow.md)
    - [常用三方库列表](advance/utils.md)

## 专题内容

- [代码风格](style-guide/intro.md)
    - [命名规范](style-guide/naming.md)
- [面向对象](object-oriented/intro.md)
    - [OO所需的特性](object-oriented/characteristics.md)
- [异步编程](async/intro.md)
    - [并发与并行](async/concurrency-parallelism.md)
- [Cargo详解](cargo/intro.md)
    - [配置参数](cargo/manifest.md)
- [性能调优](performance/intro.md)
    - [Benchmark性能测试](performance/benchmark.md)
    - [减少Runtime check](performance/runtime-check.md)
- [Unsafe](unsafe/intro.md)
    - [原始指针](unsafe/raw-pointer.md)
- [宏编程](macro/intro.md)
    - [过程宏](macro/procedure-macro.md)
- [常用三方库](third-party/intro.md)
    - [serde](third-party/serde.md)

## 场景模版

- [场景示例](use-case/intro.md)